libosmo-sigtran 2.2.1.64-e866 Osmocom SIGTRAN library

Macros | Enumerations | Functions | Variables
xua_internal.h File Reference
`#include <unistd.h>`
`#include <stdint.h>`
`#include <osmocom/core/tdef.h>`
`#include <osmocom/sigtran/osmo_ss7.h>`
`#include "xua_msg.h"`

Go to the source code of this file.

## Macros
#define | M3UA_MSG_SIZE 2048
#define | M3UA_MSG_HEADROOM 512

## Enumerations
enum | ss7_asp_lm_timer { SS7_ASP_LM_T_WAIT_ASP_UP = 1 , SS7_ASP_LM_T_WAIT_NOTIFY , SS7_ASP_LM_T_WAIT_NOTIY_RKM , SS7_ASP_LM_T_WAIT_RK_REG_RESP , SS7_ASP_LM_TIMERS_LEN }

## Functions
int | sua_addr_parse_part (struct osmo_sccp_addr *out, const struct xua_msg_part *param)
| parse SCCP address from given xUA message part More...
int | sua_addr_parse (struct osmo_sccp_addr *out, struct xua_msg *xua, uint16_t iei)
| parse SCCP address from given xUA message IE More...
int | sua_parse_gt (struct osmo_sccp_gt *gt, const uint8_t *data, unsigned int datalen)
| Decode SUA Global Title according to RFC3868 Section 3.10.2.3. More...
struct xua_msg * | osmo_sccp_to_xua (const struct msgb *msg)
| convert SCCP message to a SUA message More...
struct msgb * | osmo_sua_to_sccp (const struct xua_msg *xua)
| convert parsed SUA message to SCCP message More...
int | sua_rx_msg (struct osmo_ss7_asp *asp, struct msgb *msg)
| process SUA message received from socket More...
int | sua_tx_xua_as (struct osmo_ss7_as *as, struct xua_msg *xua)
| Send a given xUA message via a given SUA Application Server. More...
void | sua_tx_snm_available (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const uint32_t *aff_ssn, const uint32_t *smi, const char *info_string, bool available)
| Transmit SSNM DUNA/DAVA message indicating [un]availability of certain point code[s]. More...
void | sua_tx_snm_congestion (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const uint32_t *ssn, const uint8_t cong_level, const char *info_string)
| Transmit SSNM SCON message indicating congestion. More...
void | sua_tx_snm_daud (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const uint32_t *aff_ssn, const uint32_t *smi, const char *info_string)
| Transmit SSNM DAUD message requesting [un]availability status of certain point code[s]. More...
void | sua_tx_dupu (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, uint32_t dpc, uint16_t user, uint16_t cause, const char *info_str)
| Transmit SSNM DUPU message indicating user unavailability. More...
struct xua_msg * | sua_encode_dupu (const uint32_t *rctx, unsigned int num_rctx, uint32_t dpc, uint16_t user, uint16_t cause, const char *info_string)
struct xua_msg * | sua_gen_cldr (const struct xua_msg *xua_in, uint32_t route_ctx, uint32_t ret_cause)
struct msgb * | m3ua_to_msg (struct xua_msg *xua)
int | m3ua_tx_xua_as (struct osmo_ss7_as *as, struct xua_msg *xua)
| Send a given xUA message via a given M3UA Application Server. More...
void | m3ua_tx_snm_available (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const char *info_string, bool available)
| Transmit SSNM DUNA/DAVA message indicating [un]availability of certain point code[s]. More...
void | m3ua_tx_snm_congestion (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const uint32_t *concerned_dpc, const uint8_t *cong_level, const char *info_string)
| Transmit SSNM SCON message indicating congestion. More...
void | m3ua_tx_snm_daud (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const char *info_string)
| Transmit SSNM DAUD message requesting [un]availability status of certain point code[s]. More...
void | m3ua_tx_dupu (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, uint32_t dpc, uint16_t user, uint16_t cause, const char *info_str)
| Transmit SSNM DUPU message indicating user unavailability. More...
struct xua_msg * | m3ua_encode_duna (const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const char *info_string)
struct xua_msg * | m3ua_encode_dupu (const uint32_t *rctx, unsigned int num_rctx, uint32_t dpc, uint16_t user, uint16_t cause, const char *info_string)
void | xua_tx_snm_available (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const char *info_str, bool available)
void | xua_snm_rx_daud (struct osmo_ss7_asp *asp, struct xua_msg *xua)
void | xua_snm_rx_duna (struct osmo_ss7_asp *asp, struct osmo_ss7_as *as, struct xua_msg *xua)
void | xua_snm_rx_dava (struct osmo_ss7_asp *asp, struct osmo_ss7_as *as, struct xua_msg *xua)
void | xua_snm_rx_dupu (struct osmo_ss7_asp *asp, struct osmo_ss7_as *as, struct xua_msg *xua)
void | xua_snm_rx_scon (struct osmo_ss7_asp *asp, struct osmo_ss7_as *as, struct xua_msg *xua)
int | m3ua_rx_msg (struct osmo_ss7_asp *asp, struct msgb *msg)
| process M3UA message received from socket More...
struct msgb * | m3ua_msgb_alloc (const char *name)
struct xua_msg * | m3ua_xfer_from_data (const struct m3ua_data_hdr *data_hdr, const uint8_t *data, unsigned int data_len)
struct m3ua_data_hdr * | data_hdr_from_m3ua (const struct xua_msg *xua)
void | m3ua_dh_to_xfer_param (struct osmo_mtp_transfer_param *param, const struct m3ua_data_hdr *mdh)
void | mtp_xfer_param_to_m3ua_dh (struct m3ua_data_hdr *mdh, const struct osmo_mtp_transfer_param *param)
const char * | m3ua_ntfy_info_name (uint16_t ntfy_status_type, uint16_t ntfy_status_info)
struct xua_msg * | m3ua_encode_notify (const struct osmo_xlm_prim_notify *npar)
int | m3ua_decode_notify (struct osmo_xlm_prim_notify *npar, void *ctx, const struct xua_msg *xua)
int | m3ua_rx_rkm (struct osmo_ss7_asp *asp, struct xua_msg *xua)
struct osmo_xlm_prim * | xua_xlm_prim_alloc (enum osmo_xlm_prim_type prim_type, enum osmo_prim_operation op)
void | xua_asp_send_xlm_prim (struct osmo_ss7_asp *asp, struct osmo_xlm_prim *prim)
void | xua_asp_send_xlm_prim_simple (struct osmo_ss7_asp *asp, enum osmo_xlm_prim_type prim_type, enum osmo_prim_operation op)
void | xua_snm_pc_available (struct osmo_ss7_as *as, const uint32_t *aff_pc, unsigned int num_aff_pc, const char *info_str, bool available)
void | xua_tx_snm_daud (struct osmo_ss7_asp *asp, const uint32_t *rctx, unsigned int num_rctx, const uint32_t *aff_pc, unsigned int num_aff_pc, const char *info_str)
static const char * | ss7_asp_lm_timer_name (enum ss7_asp_lm_timer val)
int | xua_as_transmit_msg (struct osmo_ss7_as *as, struct xua_msg *xua)
int | xua_find_as_for_asp (struct osmo_ss7_as **as, const struct osmo_ss7_asp *asp, const struct xua_msg_part *rctx_ie)
| Find the AS for given ASP + optional routing context IE. More...
struct msgb * | ipa_gen_ping (void)
struct msgb * | ipa_to_msg (struct xua_msg *xua)
int | ipa_tx_xua_as (struct osmo_ss7_as *as, struct xua_msg *xua)
| Send a given xUA message via a given IPA "Application Server". More...
int | ipa_rx_msg (struct osmo_ss7_asp *asp, struct msgb *msg, uint8_t sls)
| process M3UA message received from socket More...
int | osmo_isup_party_parse (char *out_digits, const uint8_t *in, unsigned int in_num_bytes, bool odd)
| Parse ISUP style address of BCD digets. More...
int | osmo_sccp_addr_parse (struct osmo_sccp_addr *out, const uint8_t *addr, unsigned int addrlen)
| Parse wire-encoded SCCP address into osmo_sccp_addr. More...
int | osmo_sccp_addr_encode (struct msgb *msg, const struct osmo_sccp_addr *in)
| encode a SCCP address from parsed format to wire format More...
int | ss7_asp_rx_unknown (struct osmo_ss7_asp *asp, int ppid_mux, struct msgb *msg)
void | xua_rkm_send_reg_req (struct osmo_ss7_asp *asp, const struct osmo_ss7_routing_key *rkey, enum osmo_ss7_as_traffic_mode traf_mode)
void | xua_rkm_send_dereg_req (struct osmo_ss7_asp *asp, uint32_t route_ctx)

## Variables
const struct xua_msg_class | m3ua_msg_class_mgmt
const struct xua_msg_class | m3ua_msg_class_snm
const struct xua_msg_class | m3ua_msg_class_rkm
const struct xua_msg_class | m3ua_msg_class_aspsm
const struct xua_msg_class | m3ua_msg_class_asptm
const struct value_string | m3ua_snm_msgt_names []
const struct value_string | m3ua_err_names []
const struct value_string | m3ua_ntfy_type_names []
const struct value_string | m3ua_ntfy_stchg_names []
const struct value_string | m3ua_ntfy_other_names []
const struct osmo_tdef | ss7_asp_lm_timer_defaults [SS7_ASP_LM_TIMERS_LEN]
const struct value_string | ss7_asp_lm_timer_names []
struct osmo_fsm | xua_default_lm_fsm
const struct value_string | m3ua_rkm_reg_status_vals []
const struct value_string | m3ua_rkm_dereg_status_vals []
const struct value_string | m3ua_rkm_msgt_names []

## Macro Definition Documentation

## ◆ M3UA_MSG_HEADROOM

#define M3UA_MSG_HEADROOM 512

## ◆ M3UA_MSG_SIZE

#define M3UA_MSG_SIZE 2048

## Enumeration Type Documentation

## ◆ ss7_asp_lm_timer

enum ss7_asp_lm_timer

Enumerator
SS7_ASP_LM_T_WAIT_ASP_UP |
SS7_ASP_LM_T_WAIT_NOTIFY |
SS7_ASP_LM_T_WAIT_NOTIY_RKM |
SS7_ASP_LM_T_WAIT_RK_REG_RESP |
SS7_ASP_LM_TIMERS_LEN |

## Function Documentation

## ◆ data_hdr_from_m3ua()

struct m3ua_data_hdr * data_hdr_from_m3ua | ( | const struct xua_msg * | xua | ) |

References xua_msg_part::dat, xua_msg::hdr, M3UA_IEI_PROT_DATA, M3UA_MSGC_XFER, M3UA_XFER_DATA, xua_common_hdr::msg_class, xua_common_hdr::msg_type, NULL, and xua_msg_find_tag().

Referenced by mtp3_hmdt_message_for_distribution().

## ◆ ipa_gen_ping()

struct msgb * ipa_gen_ping | ( | void |  | ) |

References NULL.

Referenced by ipa_t_beat_send().

## ◆ ipa_rx_msg()

int ipa_rx_msg | ( | struct osmo_ss7_asp * | asp,
|  | struct msgb * | msg,
|  | uint8_t | sls
| ) |  |

process M3UA message received from socket

Parameters

  [in] | asp | Application Server Process receiving msg
  [in] | msg | received message buffer. It is kept owned by the caller.
  [in] | sls | The SLS (signaling link selector) field to use in the generated M3UA header

Returns
  0 on success; negative on error

References osmo_ss7_asp::cfg, ipa_rx_msg_ccm(), ipa_rx_msg_osmo_ext_tcap_routing(), ipa_rx_msg_up(), OSMO_SS7_ASP_PROT_IPA, osmo_ss7_asp::proto, and sls.

Referenced by ipa_cli_read_cb(), and ss7_asp_ipa_srv_conn_rx_cb().

## ◆ ipa_to_msg()

struct msgb * ipa_to_msg | ( | struct xua_msg * | xua | ) |

References xua_msg_part::dat, xua_msg_part::len, M3UA_IEI_PROT_DATA, MTP_SI_NI11_OSMO_IPA, MTP_SI_SCCP, NULL, m3ua_data_hdr::si, and xua_msg_find_tag().

Referenced by xua_as_encode_msg().

## ◆ ipa_tx_xua_as()

int ipa_tx_xua_as | ( | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

Send a given xUA message via a given IPA "Application Server".

Parameters

  [in] | as | Application Server through which to send xua
  [in] | xua | xUA message to be sent

Returns
  0 on success; negative on error

This function takes ownership of xua msg passed to it.

References osmo_ss7_as::cfg, OSMO_SS7_ASP_PROT_IPA, osmo_ss7_as::proto, and xua_as_transmit_msg().

Referenced by mtp3_hmrt_message_for_routing().

## ◆ m3ua_decode_notify()

int m3ua_decode_notify | ( | struct osmo_xlm_prim_notify * | npar,
|  | void * | ctx,
|  | const struct xua_msg * | xua
| ) |  |

References osmo_xlm_prim_notify::asp_id, xua_msg_part::dat, osmo_xlm_prim_notify::info_string, xua_msg_part::len, M3UA_IEI_ASP_ID, M3UA_IEI_INFO_STRING, M3UA_IEI_ROUTE_CTX, M3UA_IEI_STATUS, NOTIFY_PAR_P_ASP_ID, NOTIFY_PAR_P_ROUTE_CTX, NULL, osmo_xlm_prim_notify::presence, osmo_xlm_prim_notify::route_ctx, osmo_xlm_prim_notify::route_ctx_count, osmo_xlm_prim_notify::status_info, osmo_xlm_prim_notify::status_type, xua_msg_find_tag(), and xua_msg_part_get_u32().

Referenced by m3ua_rx_mgmt_ntfy(), and sua_rx_mgmt_ntfy().

## ◆ m3ua_dh_to_xfer_param()

void m3ua_dh_to_xfer_param | ( | struct osmo_mtp_transfer_param * | param,
|  | const struct m3ua_data_hdr * | mdh
| ) |  |

References osmo_mtp_transfer_param::dpc, m3ua_data_hdr::dpc, m3ua_data_hdr::mp, m3ua_data_hdr::ni, osmo_mtp_transfer_param::opc, m3ua_data_hdr::opc, m3ua_data_hdr::si, osmo_mtp_transfer_param::sio, osmo_mtp_transfer_param::sls, and m3ua_data_hdr::sls.

Referenced by ipa_rx_msg_up(), m3ua_rx_xfer(), and m3ua_to_xfer_ind().

## ◆ m3ua_encode_duna()

struct xua_msg * m3ua_encode_duna | ( | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const char * | info_string
| ) |  |

References xua_msg::hdr, M3UA_IEI_AFFECTED_PC, M3UA_IEI_INFO_STRING, M3UA_IEI_ROUTE_CTX, M3UA_MSGC_SNM, M3UA_SNM_DUNA, M3UA_VERSION, xua_common_hdr::version, XUA_HDR, xua_msg_add_data(), and xua_msg_alloc().

Referenced by gen_duna_ret_msg(), m3ua_encode_daud(), m3ua_encode_dava(), and m3ua_tx_snm_available().

## ◆ m3ua_encode_dupu()

struct xua_msg * m3ua_encode_dupu | ( | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | uint32_t | dpc,
|  | uint16_t | user,
|  | uint16_t | cause,
|  | const char * | info_string
| ) |  |

References dpc, xua_msg::hdr, M3UA_IEI_AFFECTED_PC, M3UA_IEI_INFO_STRING, M3UA_IEI_ROUTE_CTX, M3UA_IEI_USER_CAUSE, M3UA_MSGC_SNM, M3UA_SNM_DUPU, M3UA_VERSION, xua_common_hdr::version, XUA_HDR, xua_msg_add_data(), xua_msg_add_u32(), and xua_msg_alloc().

Referenced by gen_dupu_ret_msg(), and m3ua_tx_dupu().

## ◆ m3ua_encode_notify()

struct xua_msg * m3ua_encode_notify | ( | const struct osmo_xlm_prim_notify * | npar | ) |

References osmo_xlm_prim_notify::asp_id, xua_msg::hdr, osmo_xlm_prim_notify::info_string, M3UA_IEI_ASP_ID, M3UA_IEI_INFO_STRING, M3UA_IEI_ROUTE_CTX, M3UA_IEI_STATUS, M3UA_MGMT_NTFY, M3UA_MSGC_MGMT, M3UA_NOTIFY, NOTIFY_PAR_P_ASP_ID, NOTIFY_PAR_P_ROUTE_CTX, osmo_xlm_prim_notify::presence, osmo_xlm_prim_notify::route_ctx, osmo_xlm_prim_notify::route_ctx_count, osmo_xlm_prim_notify::status_info, osmo_xlm_prim_notify::status_type, XUA_HDR, xua_msg_add_data(), xua_msg_add_u32(), xua_msg_add_u32_data(), and xua_msg_alloc().

Referenced by encode_notify().

## ◆ m3ua_msgb_alloc()

struct msgb * m3ua_msgb_alloc | ( | const char * | name | ) |

References M3UA_MSG_HEADROOM, and M3UA_MSG_SIZE.

Referenced by m3ua_rx_rkm_dereg_req(), m3ua_rx_rkm_reg_req(), mtp_prim_msgb_alloc(), mtp_prim_xfer_ind_alloc(), xua_rkm_send_dereg_req(), and xua_rkm_send_reg_req().

## ◆ m3ua_ntfy_info_name()

const char * m3ua_ntfy_info_name | ( | uint16_t | ntfy_status_type,
|  | uint16_t | ntfy_status_info
| ) |  |

References M3UA_NOTIFY_T_OTHER, M3UA_NOTIFY_T_STATCHG, m3ua_ntfy_other_names, and m3ua_ntfy_stchg_names.

Referenced by as_notify_all_asp(), m3ua_rx_mgmt_ntfy(), and tx_notify().

## ◆ m3ua_rx_msg()

int m3ua_rx_msg | ( | struct osmo_ss7_asp * | asp,
|  | struct msgb * | msg
| ) |  |

process M3UA message received from socket

Parameters

  [in] | asp | Application Server Process receiving msg
  [in] | msg | received message buffer

Returns
  0 on success; negative on error

References osmo_ss7_asp::cfg, xua_common_hdr::data, err, xua_msg::hdr, LOGPASP, M3UA_ERR_INVAL_STREAM_ID, M3UA_ERR_INVALID_VERSION, M3UA_ERR_MISSING_PARAM, M3UA_ERR_PARAM_FIELD_ERR, M3UA_ERR_UNSUPP_MSG_CLASS, m3ua_gen_error_msg(), M3UA_MSGC_ASPSM, M3UA_MSGC_ASPTM, M3UA_MSGC_MGMT, M3UA_MSGC_RKM, M3UA_MSGC_SNM, M3UA_MSGC_XFER, m3ua_rx_asp(), m3ua_rx_mgmt(), m3ua_rx_rkm(), m3ua_rx_snm(), m3ua_rx_xfer(), m3ua_tx_xua_asp(), M3UA_VERSION, xua_common_hdr::msg_class, NULL, OSMO_SS7_ASP_PROT_M3UA, osmo_ss7_asp::proto, xua_common_hdr::version, xua_dialect_check_all_mand_ies(), xua_dialect_m3ua, xua_from_msg(), xua_hdr_dump(), and xua_msg_free().

Referenced by m3ua_tcp_rx_msg(), and xua_rx_msg().

## ◆ m3ua_rx_rkm()

int m3ua_rx_rkm | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

References ENSURE_ASP_OR_IPSP, ENSURE_SG_OR_IPSP, xua_msg::hdr, LOGPASP, M3UA_RKM_DEREG_REQ, M3UA_RKM_DEREG_RSP, M3UA_RKM_REG_REQ, M3UA_RKM_REG_RSP, m3ua_rx_rkm_dereg_req(), m3ua_rx_rkm_dereg_rsp(), m3ua_rx_rkm_reg_req(), m3ua_rx_rkm_reg_rsp(), xua_common_hdr::msg_type, and xua_msg_free().

Referenced by m3ua_rx_msg().

## ◆ m3ua_to_msg()

struct msgb * m3ua_to_msg | ( | struct xua_msg * | xua | ) |

References xua_msg::hdr, M3UA_MSGC_XFER, M3UA_PPID, M3UA_VERSION, xua_common_hdr::msg_class, NULL, and xua_to_msg().

Referenced by m3ua_tx_xua_asp(), and xua_as_encode_msg().

## ◆ m3ua_tx_dupu()

void m3ua_tx_dupu | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | uint32_t | dpc,
|  | uint16_t | user,
|  | uint16_t | cause,
|  | const char * | info_str
| ) |  |

Transmit SSNM DUPU message indicating user unavailability.

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | dpc | affected point code
  [in] | user | the user (SI) that is unavailable
  [in] | cause | the cause of the user unavailability
  [in] | info_string | optional information string (can be NULL).

References dpc, m3ua_encode_dupu(), and m3ua_tx_xua_asp().

Referenced by xua_tx_upu().

## ◆ m3ua_tx_snm_available()

void m3ua_tx_snm_available | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const char * | info_string,
|  | bool | available
| ) |  |

Transmit SSNM DUNA/DAVA message indicating [un]availability of certain point code[s].

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | aff_pc | array of 'Affected Point Code' in network byte order.
  [in] | num_aff_pc | number of aff_pc
  [in] | info_string | optional information string (can be NULL).
  [in] | available | are aff_pc now available (true) or unavailable (false)

References m3ua_encode_dava(), m3ua_encode_duna(), and m3ua_tx_xua_asp().

Referenced by xua_tx_snm_available().

## ◆ m3ua_tx_snm_congestion()

void m3ua_tx_snm_congestion | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const uint32_t * | concerned_dpc,
|  | const uint8_t * | cong_level,
|  | const char * | info_string
| ) |  |

Transmit SSNM SCON message indicating congestion.

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | aff_pc | array of 'Affected Point Code' in network byte order.
  [in] | num_aff_pc | number of aff_pc
  [in] | concerned_dpc | optional concerned DPC (can be NULL)
  [in] | cong_level | optional congestion level (can be NULL)
  [in] | info_string | optional information string (can be NULL).

References xua_msg::hdr, M3UA_IEI_AFFECTED_PC, M3UA_IEI_CONC_DEST, M3UA_IEI_CONG_IND, M3UA_IEI_INFO_STRING, M3UA_IEI_ROUTE_CTX, M3UA_MSGC_SNM, M3UA_SNM_SCON, m3ua_tx_xua_asp(), M3UA_VERSION, xua_common_hdr::version, XUA_HDR, xua_msg_add_data(), xua_msg_add_u32(), and xua_msg_alloc().

Referenced by xua_tx_scon().

## ◆ m3ua_tx_snm_daud()

void m3ua_tx_snm_daud | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const char * | info_string
| ) |  |

Transmit SSNM DAUD message requesting [un]availability status of certain point code[s].

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | aff_pc | array of 'Affected Point Code' in network byte order.
  [in] | num_aff_pc | number of aff_pc
  [in] | info_string | optional information string (can be NULL).

References m3ua_encode_daud(), and m3ua_tx_xua_asp().

Referenced by xua_tx_snm_daud().

## ◆ m3ua_tx_xua_as()

int m3ua_tx_xua_as | ( | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

Send a given xUA message via a given M3UA Application Server.

Parameters

  [in] | as | Application Server through which to send xua
  [in] | xua | xUA message to be sent

Returns
  0 on success; negative on error

This function takes ownership of xua msg passed to it.

References osmo_ss7_as::cfg, osmo_ss7_routing_key::context, osmo_ss7_as::fi, M3UA_IEI_ROUTE_CTX, OSMO_SS7_ASP_PROT_M3UA, osmo_ss7_as::proto, osmo_ss7_as::routing_key, XUA_AS_E_TRANSFER_REQ, xua_msg_add_u32(), and xua_msg_free().

Referenced by mtp3_hmdt_rx_msg_for_local_unavailable_part(), mtp3_hmrt_message_for_routing(), and mtp3_rtpc_rx_msg_for_inaccessible_sp().

## ◆ m3ua_xfer_from_data()

struct xua_msg * m3ua_xfer_from_data | ( | const struct m3ua_data_hdr * | data_hdr,
|  | const uint8_t * | data,
|  | unsigned int | data_len
| ) |  |

References xua_msg_part::dat, data, xua_msg_part::entry, xua_msg::hdr, xua_msg::headers, xua_msg_part::len, M3UA_IEI_PROT_DATA, M3UA_MSGC_XFER, M3UA_XFER_DATA, xua_msg_part::tag, XUA_HDR, and xua_msg_alloc().

Referenced by ipa_rx_msg_up(), and mtp3_hmrt_mtp_xfer_request_l4_to_l3().

## ◆ mtp_xfer_param_to_m3ua_dh()

void mtp_xfer_param_to_m3ua_dh | ( | struct m3ua_data_hdr * | mdh,
|  | const struct osmo_mtp_transfer_param * | param
| ) |  |

References osmo_mtp_transfer_param::dpc, m3ua_data_hdr::dpc, m3ua_data_hdr::mp, m3ua_data_hdr::ni, osmo_mtp_transfer_param::opc, m3ua_data_hdr::opc, m3ua_data_hdr::si, osmo_mtp_transfer_param::sio, osmo_mtp_transfer_param::sls, and m3ua_data_hdr::sls.

Referenced by mtp3_hmrt_mtp_xfer_request_l4_to_l3().

## ◆ osmo_isup_party_parse()

int osmo_isup_party_parse | ( | char * | out_digits,
|  | const uint8_t * | in,
|  | unsigned int | in_num_bytes,
|  | bool | odd
| ) |  |

Parse ISUP style address of BCD digets.

Parameters

  [out] | out_digits | user-allocated buffer for ASCII digits
  [in] | in | BCD-encoded digits
  [in] | in_num_bytes | Size of in in bytes
  [in] | odd | Odd (true) or even (false) number of digits

Returns
  number of digits generated

Referenced by osmo_sccp_addr_parse().

## ◆ osmo_sccp_addr_encode()

int osmo_sccp_addr_encode | ( | struct msgb * | msg,
|  | const struct osmo_sccp_addr * | in
| ) |  |

encode a SCCP address from parsed format to wire format

Parameters

  [out] | msg | message buffer to which address is to be appended
  [in] | in | data structure describing SCCP address

Returns
  number of bytes written to msg

References osmo_sccp_gt::digits, osmo_sccp_addr::gt, osmo_sccp_gt::gti, msgb_put_u16le(), osmo_sccp_gt::nai, osmo_sccp_gt::npi, osmo_isup_party_encode(), OSMO_SCCP_ADDR_T_GT, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_ADDR_T_SSN, OSMO_SCCP_GTI_NAI_ONLY, OSMO_SCCP_GTI_NO_GT, OSMO_SCCP_GTI_TT_NPL_ENC, OSMO_SCCP_GTI_TT_NPL_ENC_NAI, OSMO_SCCP_GTI_TT_ONLY, OSMO_SCCP_RI_GT, OSMO_SCCP_RI_SSN_PC, osmo_sccp_addr::pc, osmo_sccp_addr::presence, osmo_sccp_addr::ri, osmo_sccp_addr::ssn, and osmo_sccp_gt::tt.

Referenced by sua_addr_to_sccp().

## ◆ osmo_sccp_addr_parse()

int osmo_sccp_addr_parse | ( | struct osmo_sccp_addr * | out,
|  | const uint8_t * | addr,
|  | unsigned int | addrlen
| ) |  |

Parse wire-encoded SCCP address into osmo_sccp_addr.

Parameters

  [out] | out | user-allocated output data structure
  [in] | addr | wire-encoded SCCP address
  [in] | addrlen | Size of addr in bytes

Returns
  0 in case of success, negative on error According to Q.713/3.4 and RFC3868/3.10.2

References osmo_sccp_gt::digits, osmo_sccp_addr::gt, osmo_sccp_gt::gti, osmo_sccp_gt::nai, osmo_sccp_gt::npi, osmo_isup_party_parse(), OSMO_SCCP_ADDR_T_GT, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_ADDR_T_SSN, OSMO_SCCP_GTI_NAI_ONLY, OSMO_SCCP_GTI_NO_GT, OSMO_SCCP_GTI_TT_NPL_ENC, OSMO_SCCP_GTI_TT_NPL_ENC_NAI, OSMO_SCCP_GTI_TT_ONLY, OSMO_SCCP_RI_GT, OSMO_SCCP_RI_SSN_PC, osmo_sccp_addr::pc, osmo_sccp_addr::presence, osmo_sccp_addr::ri, osmo_sccp_addr::ssn, and osmo_sccp_gt::tt.

Referenced by sccp_addr_to_sua().

## ◆ osmo_sccp_to_xua()

struct xua_msg * osmo_sccp_to_xua | ( | const struct msgb * | msg | ) |

convert SCCP message to a SUA message

Parameters

  [in] | msg | message buffer holding SCCP message at l2h

Returns
  callee-allocated xUA message on success; NULL on error

References xua_msg::hdr, NULL, sccp_to_xua_cc(), sccp_to_xua_cr(), sccp_to_xua_cref(), sccp_to_xua_dt1(), sccp_to_xua_err(), sccp_to_xua_it(), sccp_to_xua_ludt(), sccp_to_xua_ludts(), sccp_to_xua_rlc(), sccp_to_xua_rlsd(), sccp_to_xua_udt(), sccp_to_xua_udts(), sccp_to_xua_xudt(), sccp_to_xua_xudts(), SUA_CL_CLDR, SUA_CL_CLDT, SUA_CO_COAK, SUA_CO_CODT, SUA_CO_COERR, SUA_CO_COIT, SUA_CO_CORE, SUA_CO_COREF, SUA_CO_RELCO, SUA_CO_RELRE, SUA_MSGC_CL, SUA_MSGC_CO, XUA_HDR, xua_msg_alloc(), and xua_msg_free().

Referenced by asp_loadshare_tcap_sccp(), mtp_user_prim_cb(), patch_sccp_with_pc(), and tcap_as_rx_sccp_asp().

## ◆ osmo_sua_to_sccp()

struct msgb * osmo_sua_to_sccp | ( | const struct xua_msg * | xua | ) |

convert parsed SUA message to SCCP message

Parameters

  [in] | xua | parsed SUA message to be converted

Returns
  callee-allocated msgb containing encoded SCCP message

References xua_msg::hdr, xua_common_hdr::msg_class, xua_common_hdr::msg_type, NULL, sccp_msgb_alloc(), SUA_CL_CLDR, SUA_CL_CLDT, SUA_CO_COAK, SUA_CO_CODT, SUA_CO_COERR, SUA_CO_COIT, SUA_CO_CORE, SUA_CO_COREF, SUA_CO_RELCO, SUA_CO_RELRE, SUA_MSGC_CL, SUA_MSGC_CO, sua_to_sccp_cc(), sua_to_sccp_cr(), sua_to_sccp_cref(), sua_to_sccp_dt1(), sua_to_sccp_err(), sua_to_sccp_it(), sua_to_sccp_rlc(), sua_to_sccp_rlsd(), sua_to_sccp_udt(), sua_to_sccp_udts(), xua_dialect_sua, and xua_hdr_dump().

Referenced by patch_sccp_with_pc(), send_back_udts(), and sua2sccp_tx_m3ua().

## ◆ ss7_asp_lm_timer_name()

static const char * ss7_asp_lm_timer_name | ( | enum ss7_asp_lm_timer | val | ) |
| inlinestatic

References ss7_asp_lm_timer_names.

## ◆ ss7_asp_rx_unknown()

int ss7_asp_rx_unknown | ( | struct osmo_ss7_asp * | asp,
|  | int | ppid_mux,
|  | struct msgb * | msg
| ) |  |

References osmo_ss7_asp::cfg, osmo_ss7_asp::ctrg, osmo_ss7_instance::ctrg, g_osmo_ss7_asp_rx_unknown_cb, osmo_ss7_asp::inst, LOGPASP, OSMO_SS7_ASP_PROT_IPA, osmo_ss7_asp::proto, SS7_ASP_CTR_PKT_RX_UNKNOWN, and SS7_INST_CTR_PKT_RX_UNKNOWN.

Referenced by xua_rx_msg().

## ◆ sua_addr_parse()

int sua_addr_parse | ( | struct osmo_sccp_addr * | out,
|  | struct xua_msg * | xua,
|  | uint16_t | iei
| ) |  |

parse SCCP address from given xUA message IE

Parameters

  [out] | out | caller-allocated decoded SCCP address struct
  [in] | xua | xUA message
  [in] | iei | Information Element Identifier inside xua

Returns
  0 on success; negative on error

References sua_addr_parse_part(), and xua_msg_find_tag().

Referenced by asp_loadshare_tcap_sccp(), ensure_opc_in_calling_ssn(), gen_mtp_transfer_req_xua(), patch_sccp_with_pc(), sccp_conn_scu_gen_encode_and_send(), sccp_find_user(), sccp_scrc_rx_sclc_msg(), sccp_scrc_rx_scoc_conn_msg(), sclc_rx_cldr(), sclc_rx_cldt(), scoc_fsm_idle(), scrc_node_2(), scrc_rx_mtp_xfer_ind_xua(), sua_gen_cldr(), and tcap_as_rx_sccp_asp().

## ◆ sua_addr_parse_part()

int sua_addr_parse_part | ( | struct osmo_sccp_addr * | out,
|  | const struct xua_msg_part * | param
| ) |  |

parse SCCP address from given xUA message part

Parameters

  [out] | out | caller-allocated decoded SCCP address struct
  [in] | param | xUA message part containing address

Returns
  0 on success; negative on error

References xua_msg_part::dat, osmo_sccp_addr::gt, osmo_sccp_addr::ip, xua_msg_part::len, xua_parameter_hdr::len, OSMO_SCCP_ADDR_T_GT, OSMO_SCCP_ADDR_T_IPv4, OSMO_SCCP_ADDR_T_IPv6, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_ADDR_T_SSN, OSMO_SCCP_RI_GT, OSMO_SCCP_RI_SSN_IP, OSMO_SCCP_RI_SSN_PC, osmo_sccp_addr::pc, osmo_sccp_addr::presence, osmo_sccp_addr::ri, osmo_sccp_addr::ssn, SUA_IEI_GT, SUA_IEI_IPv4, SUA_IEI_IPv6, SUA_IEI_PC, SUA_IEI_SSN, sua_parse_gt(), SUA_RI_GT, SUA_RI_HOST, SUA_RI_SSN_IP, SUA_RI_SSN_PC, xua_msg_part::tag, xua_parameter_hdr::tag, osmo_sccp_addr::v4, and osmo_sccp_addr::v6.

Referenced by sua_addr_parse(), and sua_addr_to_sccp().

## ◆ sua_encode_dupu()

struct xua_msg * sua_encode_dupu | ( | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | uint32_t | dpc,
|  | uint16_t | user,
|  | uint16_t | cause,
|  | const char * | info_string
| ) |  |

References dpc, xua_msg::hdr, SUA_IEI_AFFECTED_PC, SUA_IEI_INFO_STRING, SUA_IEI_ROUTE_CTX, SUA_IEI_USER_CAUSE, SUA_MSGC_SNM, SUA_SNM_DUNA, SUA_VERSION, xua_common_hdr::version, XUA_HDR, xua_msg_add_data(), xua_msg_add_u32(), and xua_msg_alloc().

Referenced by gen_dupu_ret_msg(), and sua_tx_dupu().

## ◆ sua_gen_cldr()

struct xua_msg * sua_gen_cldr | ( | const struct xua_msg * | xua_in,
|  | uint32_t | route_ctx,
|  | uint32_t | ret_cause
| ) |  |

References xua_msg::hdr, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_RI_SSN_PC, osmo_sccp_addr::pc, osmo_sccp_addr::presence, osmo_sccp_addr::ri, sua_addr_parse(), SUA_CAUSE_T_RETURN, SUA_CL_CLDR, SUA_IEI_CAUSE, SUA_IEI_CORR_ID, SUA_IEI_DATA, SUA_IEI_DEST_ADDR, SUA_IEI_IMPORTANCE, SUA_IEI_MSG_PRIO, SUA_IEI_ROUTE_CTX, SUA_IEI_SEGMENTATION, SUA_IEI_SRC_ADDR, SUA_MSGC_CL, XUA_HDR, xua_msg_add_sccp_addr(), xua_msg_add_u32(), xua_msg_alloc(), xua_msg_copy_part(), and xua_msg_free_tag().

Referenced by gen_ret_msg(), and send_back_udts().

## ◆ sua_parse_gt()

int sua_parse_gt | ( | struct osmo_sccp_gt * | gt,
|  | const uint8_t * | data,
|  | unsigned int | datalen
| ) |  |

Decode SUA Global Title according to RFC3868 Section 3.10.2.3.

Parameters

  [out] | gt | User-allocated structure for decoded output
  [in] | data | binary-encoded data
  [in] | datalen | length of data in octets

References data, osmo_sccp_gt::digits, osmo_sccp_gt::gti, osmo_sccp_gt::nai, osmo_sccp_gt::npi, and osmo_sccp_gt::tt.

Referenced by sua_addr_parse_part().

## ◆ sua_rx_msg()

int sua_rx_msg | ( | struct osmo_ss7_asp * | asp,
|  | struct msgb * | msg
| ) |  |

process SUA message received from socket

Parameters

  [in] | asp | Application Server Process receiving msg
  [in] | msg | received message buffer

Returns
  0 on success; negative on error

References osmo_ss7_asp::cfg, osmo_ss7_instance::cfg, xua_common_hdr::data, osmo_mtp_transfer_param::dpc, err, xua_msg::hdr, osmo_ss7_asp::inst, LOGPASP, xua_common_hdr::msg_class, xua_msg::mtp, MTP_SI_SCCP, MTP_SIO, osmo_ss7_instance::network_indicator, NULL, osmo_mtp_transfer_param::opc, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_asp::proto, osmo_ss7_instance::sccp, osmo_mtp_transfer_param::sio, SUA_ERR_INVAL_STREAM_ID, SUA_ERR_INVALID_VERSION, SUA_ERR_MISSING_PARAM, SUA_ERR_PARAM_FIELD_ERR, SUA_ERR_UNSUPP_MSG_CLASS, sua_gen_error_msg(), SUA_MSGC_ASPSM, SUA_MSGC_ASPTM, SUA_MSGC_CL, SUA_MSGC_CO, SUA_MSGC_MGMT, SUA_MSGC_RKM, SUA_MSGC_SNM, sua_rx_asp(), sua_rx_cl(), sua_rx_co(), sua_rx_mgmt(), sua_rx_snm(), sua_tx_xua_asp(), SUA_VERSION, xua_common_hdr::version, xua_dialect_check_all_mand_ies(), xua_dialect_sua, xua_from_msg(), xua_hdr_dump(), and xua_msg_free().

Referenced by xua_rx_msg().

## ◆ sua_tx_dupu()

void sua_tx_dupu | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | uint32_t | dpc,
|  | uint16_t | user,
|  | uint16_t | cause,
|  | const char * | info_str
| ) |  |

Transmit SSNM DUPU message indicating user unavailability.

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | dpc | affected point code
  [in] | user | the user (SI) that is unavailable
  [in] | cause | the cause of the user unavailability
  [in] | info_string | optional information string (can be NULL).

References dpc, sua_encode_dupu(), and sua_tx_xua_asp().

Referenced by xua_tx_upu().

## ◆ sua_tx_snm_available()

void sua_tx_snm_available | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const uint32_t * | aff_ssn,
|  | const uint32_t * | smi,
|  | const char * | info_string,
|  | bool | available
| ) |  |

Transmit SSNM DUNA/DAVA message indicating [un]availability of certain point code[s].

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | aff_pc | array of 'Affected Point Code' in network byte order.
  [in] | num_aff_pc | number of aff_pc
  [in] | aff_ssn | affected SSN (optional)
  [in] | smi | subsystem multiplicity indicator (optional)
  [in] | info_string | optional information strng (can be NULL).
  [in] | available | are aff_pc now available (true) or unavailable (false)

References smi, sua_encode_dava(), sua_encode_duna(), and sua_tx_xua_asp().

Referenced by sua_snm_ssn_available(), and xua_tx_snm_available().

## ◆ sua_tx_snm_congestion()

void sua_tx_snm_congestion | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const uint32_t * | ssn,
|  | const uint8_t | cong_level,
|  | const char * | info_string
| ) |  |

Transmit SSNM SCON message indicating congestion.

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | aff_pc | array of 'Affected Point Code' in network byte order.
  [in] | num_aff_pc | number of aff_pc
  [in] | ssn | optional SSN (can be NULL)
  [in] | cong_level | optional congestion level (can be NULL)
  [in] | info_string | optional information string (can be NULL).

References xua_msg::hdr, ssn, SUA_IEI_AFFECTED_PC, SUA_IEI_CONG_LEVEL, SUA_IEI_INFO_STRING, SUA_IEI_ROUTE_CTX, SUA_IEI_SSN, SUA_MSGC_SNM, SUA_SNM_SCON, SUA_VERSION, xua_common_hdr::version, XUA_HDR, xua_msg_add_data(), xua_msg_add_u32(), and xua_msg_alloc().

Referenced by xua_tx_scon().

## ◆ sua_tx_snm_daud()

void sua_tx_snm_daud | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const uint32_t * | aff_ssn,
|  | const uint32_t * | smi,
|  | const char * | info_string
| ) |  |

Transmit SSNM DAUD message requesting [un]availability status of certain point code[s].

Parameters

  [in] | asp | ASP through which to transmit message. Must be ACTIVE.
  [in] | rctx | array of Routing Contexts in network byte order.
  [in] | num_rctx | number of rctx
  [in] | aff_pc | array of 'Affected Point Code' in network byte order.
  [in] | num_aff_pc | number of aff_pc
  [in] | aff_ssn | affected SSN (optional)
  [in] | smi | subsystem multiplicity indicator (optional)
  [in] | info_string | optional information string (can be NULL).

References smi, sua_encode_daud(), and sua_tx_xua_asp().

Referenced by xua_tx_snm_daud().

## ◆ sua_tx_xua_as()

int sua_tx_xua_as | ( | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

Send a given xUA message via a given SUA Application Server.

Parameters

  [in] | as | Application Server through which to send xua
  [in] | xua | xUA message to be sent

Returns
  0 on success; negative on error

References osmo_ss7_as::cfg, osmo_ss7_routing_key::context, osmo_ss7_as::fi, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_as::proto, osmo_ss7_as::routing_key, SUA_IEI_ROUTE_CTX, XUA_AS_E_TRANSFER_REQ, xua_msg_add_u32(), and xua_msg_free().

Referenced by gen_mtp_transfer_req_xua().

## ◆ xua_as_transmit_msg()

int xua_as_transmit_msg | ( | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

References _NUM_OSMO_SS7_ASP_TMOD, osmo_ss7_as::cfg, osmo_ss7_as::fi, osmo_ss7_as::mode, NULL, OSMO_SS7_AS_TMOD_BCAST, OSMO_SS7_AS_TMOD_LOADSHARE, OSMO_SS7_AS_TMOD_OVERRIDE, OSMO_SS7_AS_TMOD_ROUNDROBIN, osmo_ss7_asp_send(), ss7_as_select_asp(), xua_as_encode_msg(), xua_as_transmit_msg_broadcast(), and xua_msg_free().

Referenced by ipa_tx_xua_as(), xua_as_fsm_active(), and xua_as_fsm_pending().

## ◆ xua_asp_send_xlm_prim()

void xua_asp_send_xlm_prim | ( | struct osmo_ss7_asp * | asp,
|  | struct osmo_xlm_prim * | prim
| ) |  |

References osmo_ss7_asp::fi, osmo_ss7_asp::lm, osmo_xlm_prim::oph, osmo_xlm_prim_name(), and osmo_xua_layer_manager::prim_cb.

Referenced by handle_rkey_dereg_resp(), handle_rkey_reg_resp(), m3ua_rx_mgmt_err(), m3ua_rx_mgmt_ntfy(), and xua_asp_send_xlm_prim_simple().

## ◆ xua_asp_send_xlm_prim_simple()

void xua_asp_send_xlm_prim_simple | ( | struct osmo_ss7_asp * | asp,
|  | enum osmo_xlm_prim_type | prim_type,
|  | enum osmo_prim_operation | op
| ) |  |

References xua_asp_send_xlm_prim(), and xua_xlm_prim_alloc().

Referenced by send_xlm_prim_simple(), ss7_asp_xua_srv_conn_closed_cb(), ss7_asp_xua_srv_conn_rx_cb(), xua_accept_cb(), xua_cli_close(), xua_cli_connect_cb(), and xua_cli_read_cb().

## ◆ xua_find_as_for_asp()

int xua_find_as_for_asp | ( | struct osmo_ss7_as ** | as,
|  | const struct osmo_ss7_asp * | asp,
|  | const struct xua_msg_part * | rctx_ie
| ) |  |

Find the AS for given ASP + optional routing context IE.

if rctx_ie == NULL, we assume that this ASP is only part of a single AS; if rctx_ie is given, then we look-up the ASP based on the routing context, and verify that this ASP is part of it.

Parameters

  [out] | as | caller-provided address-of-pointer to store the found AS
  [in] | asp | ASP for which we want to look-up the AS
  [in] | rctx_ie | routing context IE (may be NULL) to use for look-up

Returns
  0 in case of success; {M3UA,SUA}_ERR_* code in case of error.

References osmo_ss7_asp::cfg, osmo_ss7_asp::inst, LOGPASP, M3UA_ERR_INVAL_ROUT_CTX, M3UA_ERR_NO_CONFGD_AS_FOR_ASP, osmo_ss7_asp::name, NULL, osmo_ss7_asp::num_assoc_as, osmo_ss7_as_find_by_rctx(), osmo_ss7_as_has_asp(), osmo_ss7_asp_get_log_subsys(), ss7_asp_get_first_as(), and xua_msg_part_get_u32().

Referenced by m3ua_rx_snm_asp(), m3ua_rx_snm_ipsp(), m3ua_rx_snm_sg(), m3ua_rx_xfer(), sua_rx_cl(), sua_rx_co(), sua_rx_snm_asp(), sua_rx_snm_ipsp(), and sua_rx_snm_sg().

## ◆ xua_rkm_send_dereg_req()

void xua_rkm_send_dereg_req | ( | struct osmo_ss7_asp * | asp,
|  | uint32_t | route_ctx
| ) |  |

References M3UA_IEI_ROUTE_CTX, m3ua_msgb_alloc(), M3UA_MSGC_RKM, M3UA_RKM_DEREG_REQ, msgb_push_m3ua_hdr(), msgb_t16l16vp_put_u32(), and osmo_ss7_asp_send().

Referenced by osmo_xlm_sap_down().

## ◆ xua_rkm_send_reg_req()

void xua_rkm_send_reg_req | ( | struct osmo_ss7_asp * | asp,
|  | const struct osmo_ss7_routing_key * | rkey,
|  | enum osmo_ss7_as_traffic_mode | traf_mode
| ) |  |

References osmo_ss7_routing_key::context, osmo_ss7_routing_key::l_rk_id, M3UA_IEI_DEST_PC, M3UA_IEI_LOC_RKEY_ID, M3UA_IEI_ROUT_KEY, M3UA_IEI_ROUTE_CTX, M3UA_IEI_TRAF_MODE_TYP, m3ua_msgb_alloc(), M3UA_MSGC_RKM, M3UA_RKM_REG_REQ, msgb_push_m3ua_hdr(), msgb_t16l16vp_put_u32(), osmo_ss7_asp_send(), osmo_ss7_tmode_to_xua(), and osmo_ss7_routing_key::pc.

Referenced by osmo_xlm_sap_down().

## ◆ xua_snm_pc_available()

void xua_snm_pc_available | ( | struct osmo_ss7_as * | as,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const char * | info_str,
|  | bool | available
| ) |  |

References osmo_ss7_instance::asp_list, osmo_ss7_asp::cfg, osmo_ss7_as::inst, osmo_ss7_asp::list, osmo_ss7_as_has_asp(), osmo_ss7_asp_active(), OSMO_SS7_ASP_ROLE_SG, OSMO_SS7_MAX_RCTX_COUNT, osmo_ss7_asp::role, ss7_asp_get_all_rctx_be(), xua_snm_pc_available_to_mtp_users(), xua_snm_srm_pc_available(), and xua_tx_snm_available().

Referenced by as_snm_pc_available(), as_snm_pc_unavailable(), xua_as_fsm_onenter(), xua_snm_rx_dava(), and xua_snm_rx_duna().

## ◆ xua_snm_rx_daud()

void xua_snm_rx_daud | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

References xua_msg_part::dat, format_affected_pcs_c(), osmo_ss7_asp::inst, xua_msg_part::len, LOGPASP, M3UA_IEI_AFFECTED_PC, M3UA_IEI_INFO_STRING, NULL, osmo_ss7_asp_get_log_subsys(), OSMO_SS7_MAX_RCTX_COUNT, pc, osmo_ss7_instance::rtable_system, ss7_asp_get_all_rctx_be(), ss7_route_table_dpc_is_accessible(), xua_msg_find_tag(), xua_msg_get_str(), and xua_tx_snm_available().

Referenced by m3ua_rx_snm_asp(), m3ua_rx_snm_ipsp(), m3ua_rx_snm_sg(), sua_rx_snm_asp(), sua_rx_snm_ipsp(), and sua_rx_snm_sg().

## ◆ xua_snm_rx_dava()

void xua_snm_rx_dava | ( | struct osmo_ss7_asp * | asp,
|  | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

References osmo_ss7_asp::cfg, xua_msg_part::dat, format_affected_pcs_c(), osmo_ss7_asp::inst, xua_msg_part::len, LOGPASP, M3UA_IEI_AFFECTED_PC, M3UA_IEI_INFO_STRING, osmo_ss7_asp_get_log_subsys(), OSMO_SS7_ASP_PROT_SUA, OSMO_SS7_ASP_ROLE_ASP, pc, osmo_ss7_asp::proto, osmo_ss7_asp::role, smi, ssn, SUA_IEI_SMI, SUA_IEI_SSN, sua_snm_ssn_available(), xua_msg_find_tag(), xua_msg_get_str(), xua_msg_get_u32p(), xua_msg_part_get_u32(), and xua_snm_pc_available().

Referenced by m3ua_rx_snm_asp(), and sua_rx_snm_asp().

## ◆ xua_snm_rx_duna()

void xua_snm_rx_duna | ( | struct osmo_ss7_asp * | asp,
|  | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

References osmo_ss7_asp::cfg, xua_msg_part::dat, format_affected_pcs_c(), osmo_ss7_asp::inst, xua_msg_part::len, LOGPASP, M3UA_IEI_AFFECTED_PC, M3UA_IEI_INFO_STRING, osmo_ss7_asp_get_log_subsys(), OSMO_SS7_ASP_PROT_SUA, OSMO_SS7_ASP_ROLE_ASP, pc, osmo_ss7_asp::proto, osmo_ss7_asp::role, smi, ssn, SUA_IEI_SMI, SUA_IEI_SSN, sua_snm_ssn_available(), xua_msg_find_tag(), xua_msg_get_str(), xua_msg_get_u32p(), xua_msg_part_get_u32(), and xua_snm_pc_available().

Referenced by m3ua_rx_snm_asp(), and sua_rx_snm_asp().

## ◆ xua_snm_rx_dupu()

void xua_snm_rx_dupu | ( | struct osmo_ss7_asp * | asp,
|  | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

References osmo_ss7_asp::cfg, osmo_ss7_asp::inst, LOGPASP, M3UA_IEI_USER_CAUSE, mtp_si_vals, osmo_ss7_asp_get_log_subsys(), OSMO_SS7_ASP_PROT_M3UA, OSMO_SS7_ASP_PROT_SUA, OSMO_SS7_ASP_ROLE_ASP, osmo_ss7_pointcode_print(), osmo_ss7_asp::proto, osmo_ss7_asp::role, SUA_IEI_AFFECTED_PC, SUA_IEI_INFO_STRING, SUA_IEI_USER_CAUSE, xua_msg_get_str(), xua_msg_get_u32(), and xua_snm_upu().

Referenced by m3ua_rx_snm_asp(), and sua_rx_snm_asp().

## ◆ xua_snm_rx_scon()

void xua_snm_rx_scon | ( | struct osmo_ss7_asp * | asp,
|  | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

References xua_msg_part::dat, format_affected_pcs_c(), osmo_ss7_asp::inst, xua_msg_part::len, LOGPASP, M3UA_IEI_AFFECTED_PC, M3UA_IEI_CONC_DEST, M3UA_IEI_CONG_IND, M3UA_IEI_INFO_STRING, osmo_ss7_asp_get_log_subsys(), xua_msg_find_tag(), xua_msg_get_str(), xua_msg_get_u32p(), and xua_snm_scon().

Referenced by m3ua_rx_snm_asp(), m3ua_rx_snm_ipsp(), m3ua_rx_snm_sg(), sua_rx_snm_asp(), sua_rx_snm_ipsp(), and sua_rx_snm_sg().

## ◆ xua_tx_snm_available()

void xua_tx_snm_available | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const char * | info_str,
|  | bool | available
| ) |  |

References osmo_ss7_asp::cfg, m3ua_tx_snm_available(), NULL, OSMO_SS7_ASP_PROT_M3UA, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_asp::proto, and sua_tx_snm_available().

Referenced by as_tx_duna_during_asp_act(), xua_snm_pc_available(), and xua_snm_rx_daud().

## ◆ xua_tx_snm_daud()

void xua_tx_snm_daud | ( | struct osmo_ss7_asp * | asp,
|  | const uint32_t * | rctx,
|  | unsigned int | num_rctx,
|  | const uint32_t * | aff_pc,
|  | unsigned int | num_aff_pc,
|  | const char * | info_str
| ) |  |

References osmo_ss7_asp::cfg, m3ua_tx_snm_daud(), NULL, OSMO_SS7_ASP_PROT_M3UA, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_asp::proto, and sua_tx_snm_daud().

Referenced by tx_daud_pc(), and xua_asp_tx_snm_daud_address_book().

## ◆ xua_xlm_prim_alloc()

struct osmo_xlm_prim * xua_xlm_prim_alloc | ( | enum osmo_xlm_prim_type | prim_type,
|  | enum osmo_prim_operation | op
| ) |  |

References NULL, osmo_xlm_prim::oph, and XUA_SAP_LM.

Referenced by handle_rkey_dereg_resp(), handle_rkey_reg_resp(), m3ua_rx_mgmt_err(), m3ua_rx_mgmt_ntfy(), reg_req_all_assoc_as(), and xua_asp_send_xlm_prim_simple().

## Variable Documentation

## ◆ m3ua_err_names

const struct value_string m3ua_err_names[]
| extern

Referenced by m3ua_rx_mgmt_err(), peer_send_error(), and sua_rx_mgmt_err().

## ◆ m3ua_msg_class_aspsm

const struct xua_msg_class m3ua_msg_class_aspsm
| extern

## ◆ m3ua_msg_class_asptm

const struct xua_msg_class m3ua_msg_class_asptm
| extern

## ◆ m3ua_msg_class_mgmt

const struct xua_msg_class m3ua_msg_class_mgmt
| extern

## ◆ m3ua_msg_class_rkm

const struct xua_msg_class m3ua_msg_class_rkm
| extern

## ◆ m3ua_msg_class_snm

const struct xua_msg_class m3ua_msg_class_snm
| extern

## ◆ m3ua_ntfy_other_names

const struct value_string m3ua_ntfy_other_names[]
| extern

Referenced by m3ua_ntfy_info_name(), and sua_rx_mgmt_ntfy().

## ◆ m3ua_ntfy_stchg_names

const struct value_string m3ua_ntfy_stchg_names[]
| extern

Referenced by m3ua_ntfy_info_name(), and sua_rx_mgmt_ntfy().

## ◆ m3ua_ntfy_type_names

const struct value_string m3ua_ntfy_type_names[]
| extern

Referenced by as_notify_all_asp(), m3ua_rx_mgmt_ntfy(), sua_rx_mgmt_ntfy(), and tx_notify().

## ◆ m3ua_rkm_dereg_status_vals

const struct value_string m3ua_rkm_dereg_status_vals[]
| extern

Referenced by handle_rkey_dereg_resp().

## ◆ m3ua_rkm_msgt_names

const struct value_string m3ua_rkm_msgt_names[]
| extern

## ◆ m3ua_rkm_reg_status_vals

const struct value_string m3ua_rkm_reg_status_vals[]
| extern

Referenced by handle_rkey_reg_resp().

## ◆ m3ua_snm_msgt_names

const struct value_string m3ua_snm_msgt_names[]
| extern

Referenced by m3ua_rx_snm_asp(), m3ua_rx_snm_ipsp(), m3ua_rx_snm_sg(), sua_rx_snm_asp(), sua_rx_snm_ipsp(), and sua_rx_snm_sg().

## ◆ ss7_asp_lm_timer_defaults

const struct osmo_tdef ss7_asp_lm_timer_defaults[SS7_ASP_LM_TIMERS_LEN]
| extern

Referenced by gen_asp_timer_lm_cmd_strs(), and ss7_asp_alloc().

## ◆ ss7_asp_lm_timer_names

const struct value_string ss7_asp_lm_timer_names[]
| extern

Referenced by DEFUN_ATTR(), gen_asp_timer_lm_cmd_strs(), ss7_asp_lm_timer_name(), and write_asp_timers_lm().

## ◆ xua_default_lm_fsm

struct osmo_fsm xua_default_lm_fsm
| extern

Referenced by osmo_ss7_init(), and xua_layer_manager_default_alloc().